"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.reflect.construct.js");

require("core-js/modules/es.reflect.get.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeInitialTrackState = exports.WaitingForAssetState = exports.TimedTrackState = exports.PlayingState = exports.LoadingState = exports.FadingOutState = exports.FadingInState = exports.DeadAirState = void 0;

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.number.to-fixed.js");

require("core-js/modules/es.number.constructor.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.to-string.js");

var _assetFilters = require("./assetFilters");

var _AssetEnvelope = require("./mixer/AssetEnvelope");

var _utils = require("./utils");

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 Common sequence of states:
                          (if asset not available)
              =>   =>   Loading     =>  WaitingForAsset (returns to Loading after 10s)
              ↑             ↓ (asset found)            
              ↑         FadingIn 
              ↑             ↓
              ↑         PlayingState
              ↑             ↓
              ↑         FadingOutState 
              ↑             ↓
              <=   <=   DeadAirState    
                        
                        
         => WaitingForAssetState 
 */

/**
 * When Asset not loaded
 * @implements {ICommonStateProperties}
 */
var LoadingState = /*#__PURE__*/function () {
  function LoadingState(track, trackOptions) {
    _classCallCheck(this, LoadingState);

    this.track = track;
    this.trackOptions = trackOptions;
    this.asset = null;
  }
  /**
   * This will load next assets to play, and transiton to FadingInState or WaitingForAssetState if not asset if loaded
   */


  _createClass(LoadingState, [{
    key: "play",
    value: function play() {
      var _this = this;

      var track = this.track,
          trackOptions = this.trackOptions;
      var asset = track.loadNextAsset();
      var newState;

      if (asset) {
        (0, _utils.debugLogger)("Asset Length: " + (asset === null || asset === void 0 ? void 0 : asset.audio_length_in_seconds));
        var assetEnvelope = new _AssetEnvelope.AssetEnvelope(trackOptions, asset);
        newState = new FadingInState(track, trackOptions, {
          assetEnvelope: assetEnvelope
        });
        this.track.pauseAudio();
        this.track.setZeroGain();
        this.track.audioElement.addEventListener("playing", function () {
          return _this.track.playlist.playing && _this.track.transition(newState);
        }, {
          once: true
        });
        this.track.playAudio();

        this.track.playlist._client.listenHistory.addAsset(asset);

        return;
      } else {
        newState = new WaitingForAssetState(track, trackOptions);
      }

      this.track.transition(newState);
    }
  }, {
    key: "pause",
    value: function pause() {}
  }, {
    key: "finish",
    value: function finish() {}
  }, {
    key: "skip",
    value: function skip() {}
  }, {
    key: "replay",
    value: function replay() {}
  }, {
    key: "updateParams",
    value: function updateParams() {}
  }, {
    key: "toString",
    value: function toString() {
      return "Loading";
    }
  }]);

  return LoadingState;
}();
/**
 *
 *When asset is available
 */


exports.LoadingState = LoadingState;

var TimedTrackState = /*#__PURE__*/function () {
  // for logging purpse;
  function TimedTrackState(track, trackOptions) {
    _classCallCheck(this, TimedTrackState);

    this.track = track;
    this.windowScope = track.windowScope;
    this.trackOptions = trackOptions;
    this.timerId = null;
    this.intervalId = null;
  }
  /**
   * This will set a timer for next state
   * @param  {number=0} nextStateSecs
   * @returns number - seconds for nextState can be approximately called
   */


  _createClass(TimedTrackState, [{
    key: "play",
    value: function play() {
      var nextStateSecs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var timerId = this.timerId,
          timeRemainingMs = this.timeRemainingMs,
          trackId = this.track.trackId;

      if (timerId) {
        return; // state is already active/playing
      }

      if (timeRemainingMs) {
        // this means state was paused before
        var timeRemainingSecs = timeRemainingMs / 1000;
        (0, _utils.playlistTrackLog)("Resuming track #".concat(trackId, " timer: next state in ").concat(timeRemainingSecs.toFixed(1), "s"));
        this.setNextStateTimer(timeRemainingMs);
        return timeRemainingSecs;
      }

      var nextStateMs = nextStateSecs * 1000;
      this.setNextStateTimer(nextStateMs);
      return nextStateSecs;
    }
    /**
     */

  }, {
    key: "pause",
    value: function pause() {
      this.timeRemainingMs = this.clearTimer();
      (0, _utils.playlistTrackLog)("Pausing track #".concat(this.track.trackId, " timer: next state in ").concat((this.timeRemainingMs / 1000).toFixed(1)));
    }
  }, {
    key: "clearTimer",
    value: function clearTimer() {
      var now = new Date().getTime();
      var timerId = this.timerId,
          _this$timerApproximat = this.timerApproximateEndingAtMs,
          timerApproximateEndingAtMs = _this$timerApproximat === void 0 ? now : _this$timerApproximat,
          windowScope = this.windowScope;

      if (timerId) {
        windowScope.clearTimeout(timerId);
        clearInterval(this.intervalId);
        this.timerId = null;
        delete this.timerApproximateEndingAtMs;
        var timeRemainingMs = Math.max(timerApproximateEndingAtMs - now, 0);
        return timeRemainingMs;
      }

      if (this.intervalId) clearInterval(this.intervalId);
      return 0;
    }
  }, {
    key: "finish",
    value: function finish() {
      this.clearTimer();
      delete this.timeRemainingMs;
    }
  }, {
    key: "setNextStateTimer",
    value: function setNextStateTimer(timeMs) {
      var _this2 = this;

      this.timerId = this.windowScope.setTimeout(function () {
        return _this2.setNextState();
      }, timeMs);
      this.intervalId = this.windowScope.setInterval(function () {
        return _this2.log("".concat(((Number(_this2.timerApproximateEndingAtMs) - new Date().getTime()) / 1000).toFixed(1), "s remaining"));
      }, 1000);
      this.timerApproximateEndingAtMs = new Date().getTime() + timeMs;
    }
  }, {
    key: "log",
    value: function log(string) {
      (0, _utils.playlistTrackLog)("".concat(this.toString(), ": ").concat(string));
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      console.warn("Track state '".concat(this, "' does not implement a next state"));
    }
  }, {
    key: "skip",
    value: function skip() {
      this.finish();
      this.setNextState();
    }
  }, {
    key: "replay",
    value: function replay() {}
  }, {
    key: "setLoadingState",
    value: function setLoadingState() {
      var track = this.track,
          trackOptions = this.trackOptions;
      var loadingState = new LoadingState(track, trackOptions);
      track.transition(loadingState);
    } // TODO:
    // 1. Check priority by `distanceRangesFilter` with new location
    // 2. If DISCARD && current asset is not finished then first fade out and pause
    // 3. Add the asset to pausedAsset

  }, {
    key: "updateParams",
    value: function updateParams(params) {
      var track = this.track;
      if (!track.audioData.fadeout_when_filtered) return;
      if (!track.currentAsset) return; // already fading out let it finish.

      if (track.state instanceof FadingOutState) return;
      var prioriy = (0, _assetFilters.distanceRangesFilter)()(track.currentAsset, params);

      if (prioriy === _assetFilters.ASSET_PRIORITIES.DISCARD) {
        // fade out and pause only if playing
        if (track.playing) {
          track.transition(new FadingOutState(track, this.trackOptions, {
            assetEnvelope: track.assetEnvelope
          }));
          track.currentAsset.status = "paused";
          track.currentAsset.pausedFromTrackId = track.trackId;
          track.pausedAssetId = track.currentAsset.id;
          console.log("Scheduled to resume when listener comes back: #".concat(track.currentAsset.id));
        }
      }
    }
  }]);

  return TimedTrackState;
}();
/**
 *Plays silence and jumps to LoadingState
 */


exports.TimedTrackState = TimedTrackState;

var DeadAirState = /*#__PURE__*/function (_TimedTrackState) {
  _inherits(DeadAirState, _TimedTrackState);

  var _super = _createSuper(DeadAirState);

  function DeadAirState(track, trackOptions) {
    var _this3;

    _classCallCheck(this, DeadAirState);

    _this3 = _super.call(this, track, trackOptions);
    _this3.deadAirSeconds = _this3.trackOptions.randomDeadAir;
    return _this3;
  }

  _createClass(DeadAirState, [{
    key: "play",
    value: function play() {
      _get(_getPrototypeOf(DeadAirState.prototype), "play", this).call(this, this.deadAirSeconds);
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      this.setLoadingState();
    }
  }, {
    key: "toString",
    value: function toString() {
      return "DeadAir (".concat(this.deadAirSeconds.toFixed(1), "s)");
    }
  }]);

  return DeadAirState;
}(TimedTrackState);

exports.DeadAirState = DeadAirState;

var FadingInState = /*#__PURE__*/function (_TimedTrackState2) {
  _inherits(FadingInState, _TimedTrackState2);

  var _super2 = _createSuper(FadingInState);

  function FadingInState(track, trackOptions, _ref) {
    var _this4;

    var assetEnvelope = _ref.assetEnvelope;

    _classCallCheck(this, FadingInState);

    _this4 = _super2.call(this, track, trackOptions);
    _this4.assetEnvelope = assetEnvelope;
    return _this4;
  }
  /**
   * Will fadeIn
   * @memberof FadingInState
   */


  _createClass(FadingInState, [{
    key: "play",
    value: function play() {
      var track = this.track,
          fadeInDuration = this.assetEnvelope.fadeInDuration;

      var fadeInSecondsRemaining = _get(_getPrototypeOf(FadingInState.prototype), "play", this).call(this, fadeInDuration);

      if (!fadeInSecondsRemaining) return;
      var success = track.fadeIn(fadeInSecondsRemaining);
      if (!success) return this.setLoadingState();
    }
  }, {
    key: "pause",
    value: function pause() {
      _get(_getPrototypeOf(FadingInState.prototype), "pause", this).call(this);

      this.track.pauseAudio();
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      var track = this.track,
          trackOptions = this.trackOptions,
          assetEnvelope = this.assetEnvelope;
      track.transition(new PlayingState(track, trackOptions, {
        assetEnvelope: assetEnvelope
      }));
    }
  }, {
    key: "toString",
    value: function toString() {
      var _this$assetEnvelope = this.assetEnvelope,
          fadeInDuration = _this$assetEnvelope.fadeInDuration,
          assetId = _this$assetEnvelope.assetId;
      return "FadingIn Asset #".concat(assetId, " (").concat(fadeInDuration.toFixed(1), "s)");
    }
  }, {
    key: "replay",
    value: function replay() {}
  }, {
    key: "updateParams",
    value: function updateParams(mixParams) {
      _get(_getPrototypeOf(FadingInState.prototype), "updateParams", this).call(this, mixParams);
    }
  }]);

  return FadingInState;
}(TimedTrackState);

exports.FadingInState = FadingInState;

var PlayingState = /*#__PURE__*/function (_TimedTrackState3) {
  _inherits(PlayingState, _TimedTrackState3);

  var _super3 = _createSuper(PlayingState);

  function PlayingState(track, trackOptions, _ref2) {
    var _this5;

    var assetEnvelope = _ref2.assetEnvelope;

    _classCallCheck(this, PlayingState);

    _this5 = _super3.call(this, track, trackOptions);
    _this5.assetEnvelope = assetEnvelope;
    return _this5;
  }

  _createClass(PlayingState, [{
    key: "play",
    value: function play() {
      var track = this.track,
          startFadingOutSecs = this.assetEnvelope.startFadingOutSecs;

      _get(_getPrototypeOf(PlayingState.prototype), "play", this).call(this, startFadingOutSecs);

      track.playAudio();
    }
  }, {
    key: "pause",
    value: function pause() {
      _get(_getPrototypeOf(PlayingState.prototype), "pause", this).call(this);

      this.track.pauseAudio();
    }
  }, {
    key: "toString",
    value: function toString() {
      var _this$assetEnvelope2 = this.assetEnvelope,
          assetId = _this$assetEnvelope2.assetId,
          startFadingOutSecs = _this$assetEnvelope2.startFadingOutSecs;
      return "Playing asset #".concat(assetId, " (").concat(startFadingOutSecs.toFixed(1), "s)");
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      var track = this.track,
          trackOptions = this.trackOptions,
          assetEnvelope = this.assetEnvelope;
      track.transition(new FadingOutState(track, trackOptions, {
        assetEnvelope: assetEnvelope
      }));
    }
  }, {
    key: "updateParams",
    value: function updateParams(mixParams) {
      _get(_getPrototypeOf(PlayingState.prototype), "updateParams", this).call(this, mixParams);
    }
  }]);

  return PlayingState;
}(TimedTrackState);

exports.PlayingState = PlayingState;

var FadingOutState = /*#__PURE__*/function (_TimedTrackState4) {
  _inherits(FadingOutState, _TimedTrackState4);

  var _super4 = _createSuper(FadingOutState);

  function FadingOutState(track, trackOptions, _ref3) {
    var _this6;

    var assetEnvelope = _ref3.assetEnvelope;

    _classCallCheck(this, FadingOutState);

    _this6 = _super4.call(this, track, trackOptions);
    _this6.assetEnvelope = assetEnvelope;
    return _this6;
  }

  _createClass(FadingOutState, [{
    key: "play",
    value: function play() {
      var track = this.track,
          fadeOutDuration = this.assetEnvelope.fadeOutDuration,
          fadeOutLowerBound = this.trackOptions.fadeOutLowerBound;

      var remainingSeconds = _get(_getPrototypeOf(FadingOutState.prototype), "play", this).call(this, fadeOutDuration);

      track.fadeOut(remainingSeconds || fadeOutLowerBound);
    }
  }, {
    key: "pause",
    value: function pause() {
      _get(_getPrototypeOf(FadingOutState.prototype), "pause", this).call(this);

      this.track.pauseAudio();
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      this.track.transition(new DeadAirState(this.track, this.trackOptions));
    }
  }, {
    key: "finish",
    value: function finish() {
      var _this$track$currentAs, _this$track$listenEve;

      _get(_getPrototypeOf(FadingOutState.prototype), "finish", this).call(this);

      if (((_this$track$currentAs = this.track.currentAsset) === null || _this$track$currentAs === void 0 ? void 0 : _this$track$currentAs.status) === "paused") this.track.currentAsset.resume_time = this.track.audioElement.currentTime;
      (_this$track$listenEve = this.track.listenEvents) === null || _this$track$listenEve === void 0 ? void 0 : _this$track$listenEve.logAssetEnd(this.assetEnvelope.assetId);
    }
  }, {
    key: "toString",
    value: function toString() {
      var _this$assetEnvelope3 = this.assetEnvelope,
          assetId = _this$assetEnvelope3.assetId,
          fadeOutDuration = _this$assetEnvelope3.fadeOutDuration;
      return "FadingOut asset #".concat(assetId, " (").concat(fadeOutDuration.toFixed(1), "s)");
    }
  }, {
    key: "updateParams",
    value: function updateParams(mixParams) {
      _get(_getPrototypeOf(FadingOutState.prototype), "updateParams", this).call(this, mixParams);
    }
  }]);

  return FadingOutState;
}(TimedTrackState);

exports.FadingOutState = FadingOutState;
var DEFAULT_WAITING_FOR_ASSET_INTERVAL_SECONDS = 10;
/**
 *
 * State when nextAsset is becoming `null`
 * Will wait for 10 seconds and move to LoadingState to check new assets can be loaded
 * Also if location is updated will automatically move to LoadingState
 * @implements {ICommonStateProperties}
 */

var WaitingForAssetState = /*#__PURE__*/function (_TimedTrackState5) {
  _inherits(WaitingForAssetState, _TimedTrackState5);

  var _super5 = _createSuper(WaitingForAssetState);

  function WaitingForAssetState(track, trackOptions) {
    _classCallCheck(this, WaitingForAssetState);

    return _super5.call(this, track, trackOptions);
  }

  _createClass(WaitingForAssetState, [{
    key: "play",
    value: function play() {
      _get(_getPrototypeOf(WaitingForAssetState.prototype), "play", this).call(this, DEFAULT_WAITING_FOR_ASSET_INTERVAL_SECONDS);
    }
  }, {
    key: "updateParams",
    value: function updateParams() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _get(_getPrototypeOf(WaitingForAssetState.prototype), "updateParams", this).call(this, params);

      this.finish(); // move to LoadingState in case new assets are available

      this.setLoadingState();
    }
  }, {
    key: "setNextState",
    value: function setNextState() {
      this.setLoadingState();
    }
  }, {
    key: "toString",
    value: function toString() {
      return "WaitingForAsset (".concat(DEFAULT_WAITING_FOR_ASSET_INTERVAL_SECONDS, "s)");
    }
  }]);

  return WaitingForAssetState;
}(TimedTrackState);

exports.WaitingForAssetState = WaitingForAssetState;

var makeInitialTrackState = function makeInitialTrackState(track, trackOptions) {
  var startWithSilence = trackOptions.startWithSilence;
  var stateClass = startWithSilence ? DeadAirState : LoadingState;
  var newState = new stateClass(track, trackOptions);
  return newState;
};

exports.makeInitialTrackState = makeInitialTrackState;