import { AssetPriorityType } from "./assetFilters";
import { AssetSorter } from "./assetSorter";
import { PlaylistAudiotrack } from "./playlistAudioTrack";
import { IMixParams, ITimedAssetData } from "./types";
import { IDecoratedAsset, IAssetData } from "./types/asset";
export declare const assetDecorationMapper: (timedAssets: ITimedAssetData[]) => (asset: IAssetData) => IDecoratedAsset;
export declare class AssetPool {
    assetSorter: AssetSorter;
    playingTracks: {};
    mixParams: IMixParams;
    filterChain: (asset: IDecoratedAsset, mixParams: IMixParams) => AssetPriorityType;
    assets: IDecoratedAsset[];
    constructor({ assets, timedAssets, filterChain, sortMethods, mixParams, }: {
        assets?: IAssetData[];
        timedAssets?: ITimedAssetData[];
        filterChain?: (asset: IDecoratedAsset, mixParams: IMixParams) => AssetPriorityType;
        sortMethods?: string[];
        mixParams?: IMixParams;
    });
    updateAssets(assets?: IAssetData[], timedAssets?: ITimedAssetData[]): void;
    nextForTrack(track: PlaylistAudiotrack, { elapsedSeconds, filterOutAssets, listenTagIds, ...stateParams }: {
        elapsedSeconds: number;
        listenerPoint?: IMixParams[`listenerPoint`];
        listenTagIds?: IMixParams[`listenTagIds`];
        filterOutAssets: IAssetData[];
    }): IDecoratedAsset | undefined;
    sortAssets(): void;
    add(asset: IDecoratedAsset): void;
}
export default AssetPool;
