/// <reference types="node" />
import { IAudioBuffer, IAudioBufferSourceNode, IAudioContext, IGainNode } from "standardized-audio-context";
import { SpeakerConfig } from "../types/roundware";
import { ISpeakerPlayer, SpeakerConstructor } from "../types/speaker";
export declare class SpeakerPrefetchPlayer implements ISpeakerPlayer {
    isSafeToPlay: boolean;
    playing: boolean;
    loaded: boolean;
    audio: HTMLAudioElement;
    source?: IAudioBufferSourceNode<IAudioContext>;
    id: number;
    gainNode: IGainNode<IAudioContext>;
    context: IAudioContext;
    config: SpeakerConfig;
    loadedPercentage: number;
    buffer?: IAudioBuffer;
    constructor({ audioContext, id, uri, config }: SpeakerConstructor);
    started: boolean;
    play(): Promise<boolean>;
    replay(): void;
    startedAt: number;
    pausedAt: number;
    get remainingDuration(): number;
    endTimeout: NodeJS.Timeout | null;
    timerStart(): Promise<void>;
    timerStop(): void;
    initializeSource(): void;
    pause(): void;
    _fadingDestination: number;
    _fading: boolean;
    _fadingTimeout: NodeJS.Timeout | null;
    fade(toVolume?: number, duration?: number): void;
    fadeOutAndPause(): void;
    log(string: string): void;
    get volume(): number;
    loadingCallback: (number: number) => void;
    onLoadingProgress(callback: (newPercent: number) => void): void;
    endCallback: () => void;
    onEnd(callback: () => void): void;
}
