import { SpeakerConfig } from "../types/roundware";
import { ISpeakerPlayer, SpeakerConstructor } from "../types/speaker";
/**
 *
 * Basic audio utilities for playing speakers audio
 * @export
 * @class SpeakerPlayer
 */
export declare class SpeakerStreamer implements ISpeakerPlayer {
    private _fadeDuration;
    audio: HTMLAudioElement;
    private _audioSrc;
    private _gainNode;
    private _context;
    playing: boolean;
    fading: boolean;
    id: number;
    private cleanUrl;
    isSafeToPlay: boolean;
    loaded: boolean;
    loadedPercentage: number;
    config: SpeakerConfig;
    /**
     * Creates an instance of SpeakerPlayer.
     * @param {string} url URL of the audio
     * @memberof SpeakerPlayer
     */
    constructor({ audioContext, uri, id, config }: SpeakerConstructor);
    log(string: string, force?: boolean): void;
    _alreadyTryingToPlay: boolean;
    play(): Promise<boolean>;
    _fadingDestination: number;
    _fading: boolean;
    fade(toVolume?: number, durationInSeconds?: number): void;
    pause(): void;
    fadeOutAndPause(): void;
    volume(): number;
    started: boolean;
    timerStart(): void;
    timerStop(): void;
    onLoadingProgress(callback: (newPercent: number) => void): void;
    onEnd(callback: () => void): void;
    replay(): void;
}
