import { IAudioContext, IGainNode, IMediaElementAudioSourceNode } from "standardized-audio-context";
import { SpeakerConfig } from "../types/roundware";
import { ISpeakerPlayer, SpeakerConstructor } from "../types/speaker";
export declare class SpeakerSyncStreamer implements ISpeakerPlayer {
    isSafeToPlay: boolean;
    playing: boolean;
    audio: HTMLAudioElement;
    loaded: boolean;
    loadedPercentage: number;
    id: number;
    config: SpeakerConfig;
    uri: string;
    gainNode: IGainNode<IAudioContext>;
    mediaSource: IMediaElementAudioSourceNode<IAudioContext>;
    context: IAudioContext;
    private _fadingTimeout?;
    constructor({ audioContext, config, uri, id }: SpeakerConstructor);
    started: boolean;
    alreadyTrying: boolean;
    play(): Promise<boolean>;
    alert(...params: any): void;
    pause(): void;
    replay(): void;
    timerStart(): void;
    timerStop(): void;
    fadingDestination: number;
    fading: boolean;
    fade(toVolume?: number, duration?: number): void;
    fadeOutAndPause(): void;
    log(string: string): void;
    onLoadingProgress(callback: (newPercent: number) => void): void;
    onEnd(callback: () => void): void;
    syncTracker?: number;
    trackSync(): void;
}
