import { PlaylistAudiotrack } from "./playlistAudioTrack";
import { Point, Feature } from "@turf/helpers";
import { IAudioTrackData } from "./types/audioTrack";
import { IMixParams, ITrackIdMap } from "./types";
import { IDecoratedAsset } from "./types/asset";
import { Roundware } from "./roundware";
import { AssetPool } from "./assetPool";
import { IAudioContext } from "standardized-audio-context";
export declare class Playlist {
    listenerPoint: Feature<Point>;
    playingTracks: {};
    assetPool: AssetPool;
    playing: boolean;
    listenTagIds: IMixParams[`listenTagIds`];
    _client: Roundware;
    _elapsedTimeMs: number;
    trackMap: Map<PlaylistAudiotrack, IDecoratedAsset | null>;
    trackIdMap: ITrackIdMap;
    playlistLastStartedAt: Date | undefined;
    constructor({ client, audioTracks, listenerPoint, windowScope, assetPool, audioContext, ...playlistTrackOptions }: {
        client: Roundware;
        audioTracks?: IAudioTrackData[];
        listenerPoint: Feature<Point>;
        windowScope: Window;
        assetPool: AssetPool;
        audioContext: IAudioContext;
    });
    get tracks(): PlaylistAudiotrack[];
    get currentlyPlayingAssets(): IDecoratedAsset[];
    updateParams({ listenerPoint, listenTagIds, ...params }: IMixParams): void;
    play(): void;
    skip(trackId?: number): void;
    replay(trackId: number): void;
    pause(): void;
    get elapsedTimeMs(): number;
    next(forTrack: PlaylistAudiotrack): IDecoratedAsset | undefined;
}
