import { Coordinates, IUiConfig } from "./types";
import { ApiClient } from "./api-client";
import { IProjectData } from "./types/project";
export declare class Project {
    projectId: number;
    projectName: string;
    apiClient: ApiClient;
    legalAgreement: string;
    recordingRadius: number;
    maxRecordingLength?: number;
    location: Coordinates;
    outOfRangeDistance?: number;
    mixParams: {};
    listenEnabled?: boolean;
    speakerEnabled?: boolean;
    data?: IProjectData;
    constructor(newProjectId: number, { apiClient }: {
        apiClient: ApiClient;
    });
    toString(): string;
    /**
     * @param  {number} sessionId
     * @returns {Promise} sessionId | undefined
     */
    connect(sessionId: number): Promise<number | undefined>;
    /**
     * @param  {number} sessionId
     * @returns Promise<IUiConfig>
     */
    uiconfig(sessionId: number): Promise<IUiConfig>;
}
