"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

require("core-js/modules/es.symbol.async-iterator.js");

require("core-js/modules/es.symbol.to-string-tag.js");

require("core-js/modules/es.json.to-string-tag.js");

require("core-js/modules/es.math.to-string-tag.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.regexp.exec.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Roundware: true,
  GeoListenMode: true
};
Object.defineProperty(exports, "GeoListenMode", {
  enumerable: true,
  get: function get() {
    return _mixer.GeoListenMode;
  }
});
exports.Roundware = void 0;

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.map.js");

var _apiClient = require("./api-client");

var _asset2 = require("./asset");

var _assetFilters = require("./assetFilters");

Object.keys(_assetFilters).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _assetFilters[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _assetFilters[key];
    }
  });
});

var _audiotrack = require("./audiotrack");

var _warning = require("./constants/warning");

var _envelope = require("./envelope");

var _app = require("./errors/app.errors");

var _events = require("./events");

var _geoPosition = require("./geo-position");

var _mixer = require("./mixer");

var _project = require("./project");

var _session = require("./session");

var _shims = require("./shims");

var _speaker = require("./speaker");

var _timed_asset = require("./timed_asset");

var _user = require("./user");

var _helpers = require("@turf/helpers");

var _bbox3 = _interopRequireDefault(require("@turf/bbox"));

var _buffer = _interopRequireDefault(require("@turf/buffer"));

var _listenHistory = require("./listenHistory");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return generator._invoke = function (innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; }(innerFn, self, context), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; this._invoke = function (method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (object) { var keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, catch: function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/** This class is the primary integration point between Roundware's server and your application

   @example
   var roundwareServerUrl = "http://localhost:8888/api/2";
   var roundwareProjectId = 1;

   var roundware = new Roundware(window,{
     serverUrl: roundwareServerUrl,
     projectId: roundwareProjectId
   });

   function ready() {
     console.info("Connected to Roundware Server. Ready to play.");
     // this is a good place to initialize audio player controls, etc.
   }

   // Generally we throw user-friendly messages and log a more technical message
   function handleError(userErrMsg) {
     console.error("Roundware Error: " + userErrMsg);
   }

  roundware.connect().
    then(ready).
    catch(handleError);

  function startListening(streamURL) {
    console.info("Loading " + streamURL);
    // good place to connect your audio player to the audio stream
  }

  roundware.play(startListening).catch(handleError);
**/
var Roundware = /*#__PURE__*/function () {
  /** Initialize a new Roundware instance
   * @param {Object} windowScope - representing the context in which we are executing - provides references to window.navigator, window.console, etc.
   * @param {Object} options - Collection of parameters for configuring this Roundware instance
   * @param {String} options.serverUrl - identifies the Roundware server
   * @param {Number} options.projectId - identifies the Roundware project to connect
   * @param {number} options.geoListenMode - whether or not to attempt to initialize geolocation-based listening
   * @throws Will throw an error if serveUrl or projectId are missing
    TODO need to provide a more modern/ES6-aware architecture here vs burdening the constructor with all of these details **/
  function Roundware(windowScope, options) {
    _classCallCheck(this, Roundware);

    _defineProperty(this, "_speakerFilters", {});

    _defineProperty(this, "_onUpdateLocation", function () {});

    _defineProperty(this, "_onUpdateAssets", function () {});

    _defineProperty(this, "assetData", null);

    _defineProperty(this, "_onPlayAssets", function () {});

    _defineProperty(this, "uiConfig", {});

    _defineProperty(this, "_speakerData", []);

    _defineProperty(this, "_audioTracksData", null);

    _defineProperty(this, "timedAssetData", null);

    if (!windowScope) throw new _app.MissingArgumentError("windowScope", "instantiating Roundware", "window");
    if (_typeof(options) !== "object") throw new _app.MissingArgumentError("options", "instantiating Roundware", "IRoundwareConstructorOptions");
    var serverUrl = options.serverUrl,
        projectId = options.projectId,
        speakerFilters = options.speakerFilters,
        assetFilters = options.assetFilters,
        listenerLocation = options.listenerLocation,
        user = options.user,
        geoPosition = options.geoPosition,
        session = options.session,
        project = options.project,
        speaker = options.speaker,
        asset = options.asset,
        timedAsset = options.timedAsset,
        audiotrack = options.audiotrack,
        assetUpdateInterval = options.assetUpdateInterval;

    if (typeof serverUrl !== "string") {
      throw new _app.InvalidArgumentError("options.serverUrl", "string", "instantiating Roundware");
    }

    if (typeof projectId !== "number") {
      throw new _app.InvalidArgumentError("options.serverUrl", "string", "instantiating Roundware");
    }

    this.windowScope = windowScope;
    this._serverUrl = serverUrl;
    this._projectId = projectId;
    if (speakerFilters) this._speakerFilters = speakerFilters;
    this._assetFilters = assetFilters;
    if (typeof listenerLocation.longitude !== "number" && typeof listenerLocation.latitude !== "number") throw new _app.InvalidArgumentError("options.listenerLocation", "Coordinates", "instantiating Roundware");
    this.listenerLocation = listenerLocation;
    this._initialOptions = options; // By default, update the asset pool every 5 minutes.

    this._assetUpdateInterval = assetUpdateInterval || 300000;
    this.apiClient = new _apiClient.ApiClient(this._serverUrl);
    var newOptions = options;
    newOptions.apiClient = this.apiClient;
    var navigator = window.navigator; // TODO need to reorganize/refactor these classes

    this.user = user || new _user.User({
      apiClient: newOptions.apiClient,
      clientType: newOptions.clientType,
      deviceId: newOptions.deviceId
    });
    this.geoPosition = geoPosition || new _geoPosition.GeoPosition(navigator, {
      geoListenMode: newOptions.geoListenMode,
      defaultCoords: listenerLocation
    });
    this._session = session || new _session.Session(navigator, this._projectId, this.geoPosition.isEnabled, {
      apiClient: this.apiClient
    });
    this.project = project || new _project.Project(this._projectId, newOptions);
    this._speaker = speaker || new _speaker.Speaker(this._projectId, newOptions);
    this._asset = asset || new _asset2.Asset(this._projectId, newOptions);
    if (!this._asset) throw new _app.RoundwareFrameworkError("Failed to connect to assets! Please try again.");
    this._timed_asset = timedAsset || new _timed_asset.TimedAsset(this._projectId, newOptions);
    this._audiotrack = audiotrack || new _audiotrack.Audiotrack(this._projectId, newOptions);
    this.uiConfig = {};

    var mixParams = _objectSpread(_objectSpread({}, this.mixParams), this._initialOptions);

    this.mixer = new _mixer.Mixer({
      client: this,
      windowScope: this.windowScope,
      listenerLocation: this.listenerLocation,
      mixParams: mixParams
    });
    this.listenHistory = new _listenHistory.ListenHistory();
  }

  _createClass(Roundware, [{
    key: "updateLocation",
    value: function updateLocation(listenerLocation) {
      // when location is different log event
      if (this.listenerLocation.latitude != listenerLocation.latitude || this.listenerLocation.longitude != listenerLocation.longitude) {
        var _this$events;

        (_this$events = this.events) === null || _this$events === void 0 ? void 0 : _this$events.logEvent("location_update", listenerLocation);
      }

      this.listenerLocation = listenerLocation;
      this.mixer.updateParams({
        listenerLocation: listenerLocation
      });
      if (this._onUpdateLocation) this._onUpdateLocation(listenerLocation);
    }
  }, {
    key: "onUpdateLocation",
    set: function set(callback) {
      this._onUpdateLocation = callback;
      var lastCoords = this.geoPosition.getLastCoords();
      callback(lastCoords);
    }
  }, {
    key: "onUpdateAssets",
    set: function set(callback) {
      this._onUpdateAssets = callback;

      if (this.assetData) {
        callback(this.assets());
      }
    }
  }, {
    key: "onPlayAssets",
    set: function set(callback) {
      this._onPlayAssets = callback;
      callback(this.currentlyPlayingAssets);
    }
  }, {
    key: "triggerOnPlayAssets",
    value: function triggerOnPlayAssets() {
      if (typeof this._onPlayAssets == "function") {
        this._onPlayAssets(this.currentlyPlayingAssets);
      }
    }
  }, {
    key: "currentlyPlayingAssets",
    get: function get() {
      if (!this.mixer.playlist) {
        return [];
      }

      return this.mixer.playlist.currentlyPlayingAssets;
    }
  }, {
    key: "enableGeolocation",
    value: function enableGeolocation(mode) {
      if (mode === _mixer.GeoListenMode.AUTOMATIC) {
        this.geoPosition.enable();
      } else {
        this.geoPosition.disable();
      }

      this.mixer.updateParams({
        geoListenMode: mode
      });
    }
  }, {
    key: "disableGeolocation",
    value: function disableGeolocation() {
      this.geoPosition.disable();
      this.mixer.updateParams({
        geoListenMode: _mixer.GeoListenMode.DISABLED
      });
    }
    /** Initiate a connection to Roundware
     *  @return {Promise} - Can be resolved in order to get the audio stream URL, or rejected to get an error message; see example above **/

  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var _this = this;

        var _this$user, sessionId, promises;

        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                // want to start this process as soon as possible, as it can take a few seconds
                this.geoPosition.connect(function (newLocation) {
                  return _this.updateLocation(newLocation);
                });

                _shims.logger.info("Initializing Roundware for project ID ".concat(this._projectId));

                _context.next = 5;
                return (_this$user = this.user) === null || _this$user === void 0 ? void 0 : _this$user.connect();

              case 5:
                _context.next = 7;
                return this._session.connect();

              case 7:
                sessionId = _context.sent;
                this._sessionId = sessionId;
                this.events = new _events.RoundwareEvents(this._sessionId, this.apiClient);
                this.events.logEvent("start_session");
                promises = [this.project.connect(sessionId), this.project.uiconfig(sessionId).then(function (uiConfig) {
                  return _this.uiConfig = uiConfig;
                }), this._speaker.connect(this._speakerFilters).then(function (speakerData) {
                  return _this._speakerData = speakerData;
                }), this._audiotrack.connect().then(function (audioTracksData) {
                  return _this._audioTracksData = audioTracksData;
                })];
                _context.next = 14;
                return Promise.all(promises);

              case 14:
                console.info("Roundware connected");
                return _context.abrupt("return", {
                  uiConfig: this.uiConfig
                });

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](0);
                throw new _app.RoundwareConnectionError();

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 18]]);
      }));

      function connect() {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "mixParams",
    get: function get() {
      return (this.project || {}).mixParams;
    } /// Requests list of assets from the server given some filters.

  }, {
    key: "getAssets",
    value: function () {
      var _getAssets = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(options) {
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(!options && this.assetData)) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return", this.assetData);

              case 4:
                _context2.next = 6;
                return this.apiClient.get("/assets/", _objectSpread(_objectSpread({
                  project_id: this._projectId
                }, this._assetFilters), options || {}));

              case 6:
                return _context2.abrupt("return", _context2.sent);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getAssets(_x) {
        return _getAssets.apply(this, arguments);
      }

      return getAssets;
    }()
  }, {
    key: "assetPool",
    get: function get() {
      return this.mixer.assetPool;
    } /// Returns a reduced asset list by filtering the overall pool.
    /// Example: `getAssetsFromPool(allAssetFilter([distanceRangesFilter(), anyTagsFilter()]))`

  }, {
    key: "getAssetsFromPool",
    value: function () {
      var _getAssetsFromPool = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(assetFilter) {
        var extraParams,
            pool,
            mixParams,
            _args3 = arguments;
        return _regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                extraParams = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                _context3.next = 3;
                return this.loadAssetPool();

              case 3:
                pool = _context3.sent;
                mixParams = _objectSpread(_objectSpread({}, this.mixParams), extraParams);
                return _context3.abrupt("return", pool.filter(function (a) {
                  return assetFilter(a, mixParams) != _assetFilters.ASSET_PRIORITIES.DISCARD;
                }));

              case 6:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getAssetsFromPool(_x2) {
        return _getAssetsFromPool.apply(this, arguments);
      }

      return getAssetsFromPool;
    }()
  }, {
    key: "updateAssetPool",
    value: function () {
      var _updateAssetPool = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
        var _this$assetData;

        var filters, existingAssets, newAssets, pool;
        return _regeneratorRuntime().wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                filters = this._assetFilters;
                existingAssets = [];

                if (this._lastAssetUpdate) {
                  filters = _objectSpread(_objectSpread({}, filters), {}, {
                    created__gte: this._lastAssetUpdate.toISOString()
                  });
                  existingAssets = this.assets();
                }

                _context4.t0 = existingAssets;
                _context4.next = 6;
                return this._asset.connect(filters);

              case 6:
                _context4.t1 = _context4.sent;
                newAssets = _context4.t0.concat.call(_context4.t0, _context4.t1);

                if (newAssets.length !== ((_this$assetData = this.assetData) === null || _this$assetData === void 0 ? void 0 : _this$assetData.length)) {
                  this.assetData = newAssets;

                  if (typeof this._onUpdateAssets == "function") {
                    this._onUpdateAssets(this.assetData);
                  }
                } // also fetch timedAssetData if not available


                if (Array.isArray(this.timedAssetData)) {
                  _context4.next = 13;
                  break;
                }

                _context4.next = 12;
                return this._timed_asset.connect({});

              case 12:
                this.timedAssetData = _context4.sent;

              case 13:
                this._lastAssetUpdate = new Date(); // Update the mixer's asset pool, if any.

                pool = this.assetPool;

                if (pool && Array.isArray(this.timedAssetData)) {
                  pool.updateAssets(this.assetData, this.timedAssetData);
                }

                Promise.resolve();

              case 17:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function updateAssetPool() {
        return _updateAssetPool.apply(this, arguments);
      }

      return updateAssetPool;
    }()
  }, {
    key: "loadAssetPool",
    value: function () {
      var _loadAssetPool = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5() {
        var _this2 = this;

        return _regeneratorRuntime().wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (Array.isArray(this.timedAssetData)) {
                  _context5.next = 4;
                  break;
                }

                _context5.next = 3;
                return this._timed_asset.connect({});

              case 3:
                this.timedAssetData = _context5.sent;

              case 4:
                if (this.assetData) {
                  _context5.next = 8;
                  break;
                }

                _context5.next = 7;
                return this.updateAssetPool();

              case 7:
                // Setup periodic retrieval of newly uploaded assets.
                this._assetDataTimer = setInterval(function () {
                  return _this2.updateAssetPool();
                }, this._assetUpdateInterval);

              case 8:
                return _context5.abrupt("return", this.assetData);

              case 9:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function loadAssetPool() {
        return _loadAssetPool.apply(this, arguments);
      }

      return loadAssetPool;
    }()
    /**
     * Updates params with passed params, Builds playlist instance, loads assetPool
     * @param  {IMixParams} activationParams
     * @returns Mixer
     */

  }, {
    key: "activateMixer",
    value: function () {
      var _activateMixer = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
        var activationParams,
            allMixParams,
            _args6 = arguments;
        return _regeneratorRuntime().wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                activationParams = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : {};
                _context6.next = 3;
                return this.loadAssetPool();

              case 3:
                allMixParams = _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, this._initialOptions), this.mixParams), activationParams), {}, {
                  sessionId: this._sessionId
                });
                this.mixer.initContext();
                this.mixer.updateParams(allMixParams);
                return _context6.abrupt("return", this.mixer);

              case 7:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function activateMixer() {
        return _activateMixer.apply(this, arguments);
      }

      return activateMixer;
    }()
    /** Create or resume the audio stream
     * @see Mixer.toogle **/

  }, {
    key: "play",
    value: function play() {
      var firstPlayCallback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
      console.log("Playing...");
      return this.geoPosition.waitForInitialGeolocation().then(firstPlayCallback);
    }
    /** Tell Roundware server to pause the audio stream. You should always call this when the local audio player has been paused.
     * @see Mixer.playlist.pause **/

  }, {
    key: "pause",
    value: function pause() {
      if (this.mixer.playlist) {
        this.mixer.playlist.pause();
      }
    }
    /** Tell Roundware server to kill the audio stream.
     * @see Stream.kill **/

  }, {
    key: "kill",
    value: function kill() {}
    /** Tell Roundware server to replay the current asset.
     * @see Stream.replay **/

  }, {
    key: "replay",
    value: function replay() {}
    /** Tell Roundware server to skip the current asset.
     * @see Stream.skip **/

  }, {
    key: "skip",
    value: function skip() {
      if (this.mixer.playlist) {
        this.mixer.playlist.skip();
      }
    }
    /** Update the Roundware stream with new tag IDs
     * @param {string} tagIdStr - comma-separated list of tag IDs to send to the streams API **/

  }, {
    key: "tags",
    value: function tags() {}
    /** Update the Roundware stream with new tag IDs and or geo-position
     * @param {object} data - containing keys latitude, longitude and tagIds **/

  }, {
    key: "update",
    value: function update(data) {
      if (this.mixer.playlist) {
        this.mixer.playlist.updateParams(data);
      } // Object.keys(data).map(e => console.log(`key=${e}  value=${data[e]}`));

    }
  }, {
    key: "speakers",
    value: function speakers() {
      return this._speakerData || [];
    }
  }, {
    key: "assets",
    value: function assets() {
      if (!this.assetData) console.warn(_warning.noAssetData);
      return this.assetData || [];
    }
  }, {
    key: "timedAssets",
    value: function timedAssets() {
      if (!this.timedAssetData) console.warn(_warning.noAssetData);
      return this.timedAssetData || [];
    }
  }, {
    key: "audiotracks",
    value: function audiotracks() {
      return this._audioTracksData || [];
    }
    /** Attach new assets to the project
     * @param {Object} audioData - the binary data from a recording to be saved as an asset
     * @param {string} fileName - name of the file
     * @return {promise} - represents the API calls to save an asset; can be tested to find out whether upload was successful
     * @see Envelope.upload */

  }, {
    key: "saveAsset",
    value: function () {
      var _saveAsset = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(audioData, fileName, data) {
        var envelope;
        return _regeneratorRuntime().wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.makeEnvelope();

              case 2:
                envelope = _context7.sent;
                return _context7.abrupt("return", envelope.upload(audioData, fileName, data));

              case 4:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function saveAsset(_x3, _x4, _x5) {
        return _saveAsset.apply(this, arguments);
      }

      return saveAsset;
    }()
    /** Explicitly make a new envelope that you can attach multiple assets to by
     calling the `Envelope.upload` method. This is the main way to add text,
     photo, and video assets to an envelope. */

  }, {
    key: "makeEnvelope",
    value: function () {
      var _makeEnvelope = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8() {
        var envelope;
        return _regeneratorRuntime().wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (this._sessionId) {
                  _context8.next = 2;
                  break;
                }

                throw new Error("can't save assets without first connecting to the server");

              case 2:
                envelope = new _envelope.Envelope(this._sessionId, this.apiClient, this.geoPosition, this);
                _context8.next = 5;
                return envelope.connect();

              case 5:
                return _context8.abrupt("return", envelope);

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function makeEnvelope() {
        return _makeEnvelope.apply(this, arguments);
      }

      return makeEnvelope;
    }()
  }, {
    key: "findTagDescription",
    value: function findTagDescription(tagId) {
      var tagType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "listen";
      var tagGroups = this.uiConfig[tagType];

      var _iterator = _createForOfIteratorHelper(tagGroups),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var group = _step.value;

          var _iterator2 = _createForOfIteratorHelper(group.display_items),
              _step2;

          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var item = _step2.value;

              if (item.tag_id == tagId) {
                return item.tag_display_text;
              }
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return undefined;
    }
  }, {
    key: "vote",
    value: function () {
      var _vote = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(assetId, voteType, value) {
        return _regeneratorRuntime().wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt("return", this.apiClient.post("/assets/".concat(assetId, "/votes/"), {
                  session_id: this._sessionId,
                  vote_type: voteType,
                  value: value
                }));

              case 1:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function vote(_x6, _x7, _x8) {
        return _vote.apply(this, arguments);
      }

      return vote;
    }() /// @return Detailed information about a particular asset.

  }, {
    key: "getAsset",
    value: function () {
      var _getAsset = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(id) {
        var _iterator3, _step3, _asset;

        return _regeneratorRuntime().wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if (!this.assetData) {
                  _context10.next = 18;
                  break;
                }

                _iterator3 = _createForOfIteratorHelper(this.assetData);
                _context10.prev = 2;

                _iterator3.s();

              case 4:
                if ((_step3 = _iterator3.n()).done) {
                  _context10.next = 10;
                  break;
                }

                _asset = _step3.value;

                if (!(_asset.id === id)) {
                  _context10.next = 8;
                  break;
                }

                return _context10.abrupt("return", _asset);

              case 8:
                _context10.next = 4;
                break;

              case 10:
                _context10.next = 15;
                break;

              case 12:
                _context10.prev = 12;
                _context10.t0 = _context10["catch"](2);

                _iterator3.e(_context10.t0);

              case 15:
                _context10.prev = 15;

                _iterator3.f();

                return _context10.finish(15);

              case 18:
                return _context10.abrupt("return", this.apiClient.get("/assets/".concat(id, "/"), {
                  session_id: this._sessionId
                }));

              case 19:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this, [[2, 12, 15, 18]]);
      }));

      function getAsset(_x9) {
        return _getAsset.apply(this, arguments);
      }

      return getAsset;
    }() /// @return Details about a particular envelope (which may contain multiple assets).

  }, {
    key: "getEnvelope",
    value: function () {
      var _getEnvelope = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(id) {
        return _regeneratorRuntime().wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                return _context11.abrupt("return", this.apiClient.get("/envelopes/".concat(id), {
                  session_id: this._sessionId
                }));

              case 1:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getEnvelope(_x10) {
        return _getEnvelope.apply(this, arguments);
      }

      return getEnvelope;
    }()
    /**
     *
     * Calculates bounds for the map based on Speakers
     * @memberof Roundware
     */

  }, {
    key: "getMapBounds",
    value: function getMapBounds() {
      var speakersHavingShape = this.speakers().filter(function (speaker) {
        return !!speaker.shape;
      }); // get polygons from all speakers

      var polygons = speakersHavingShape.map(function (s) {
        return (0, _helpers.multiPolygon)(s.shape.coordinates);
      });
      var polygonCollection = (0, _helpers.featureCollection)(polygons); // add buffer

      this.project.outOfRangeDistance && (polygonCollection = (0, _buffer.default)(polygonCollection, this.project.outOfRangeDistance, {
        units: "meters"
      })); // order - [minX, minY, maxX, maxY]

      var _bbox = (0, _bbox3.default)(polygonCollection),
          _bbox2 = _slicedToArray(_bbox, 4),
          swLng = _bbox2[0],
          swLat = _bbox2[1],
          neLng = _bbox2[2],
          neLat = _bbox2[3];

      return {
        southwest: {
          latitude: swLat,
          longitude: swLng
        },
        northeast: {
          latitude: neLat,
          longitude: neLng
        }
      };
    }
  }]);

  return Roundware;
}();

exports.Roundware = Roundware;