import { Point, Feature } from "@turf/helpers";
import { IAudioContext } from "standardized-audio-context";
export declare const isIos: () => boolean;
/**
 * @param  {string} url
 * @returns Cleaned URL
 */
export declare const cleanAudioURL: (url: string, useM4AforIos?: boolean) => string;
/**
 * @param  {number} {latitude
 * @param  {number} longitude
 * @returns Feature<Point>
 */
export declare function coordsToPoints({ latitude, longitude, }: {
    latitude: number;
    longitude: number;
}): Feature<Point>;
export declare const isEmpty: (array: any[]) => boolean;
export declare const hasOwnProperty: (target: unknown, propName: PropertyKey) => boolean;
export declare const random: (a?: number, b?: number) => number;
export declare const randomInt: (a?: number, b?: number) => number;
export declare const UNLOCK_AUDIO_EVENTS: string[];
export declare function buildAudioContext(windowScope: Window): IAudioContext;
export declare const timestamp: {
    toString: (time?: Date) => string;
};
export declare const getUrlParam: (urlStr: string, paramName: string) => string;
export declare const NO_OP: () => void;
export declare const debugLogger: (message: string) => void;
export declare const speakerLog: (message: string) => void;
export declare const playlistTrackLog: (message: string) => void;
export declare const makeAudioSafeToPlay: (audioElement: HTMLAudioElement, audioContext: IAudioContext, onSuccess?: () => void, expectedSourceAfter?: string) => void;
export declare const NEARLY_ZERO = 0.0001;
